'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};





var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var IS_SCROLLING_DEBOUNCE_INTERVAL = 150;

function createGridComponent(_ref) {
  var _class, _temp;

  var getColumnOffset = _ref.getColumnOffset,
      getColumnStartIndexForOffset = _ref.getColumnStartIndexForOffset,
      getColumnStopIndexForStartIndex = _ref.getColumnStopIndexForStartIndex,
      getColumnWidth = _ref.getColumnWidth,
      getEstimatedTotalHeight = _ref.getEstimatedTotalHeight,
      getEstimatedTotalWidth = _ref.getEstimatedTotalWidth,
      getOffsetForColumnAndAlignment = _ref.getOffsetForColumnAndAlignment,
      getOffsetForRowAndAlignment = _ref.getOffsetForRowAndAlignment,
      getRowHeight = _ref.getRowHeight,
      getRowOffset = _ref.getRowOffset,
      getRowStartIndexForOffset = _ref.getRowStartIndexForOffset,
      getRowStopIndexForStartIndex = _ref.getRowStopIndexForStartIndex,
      initInstanceProps = _ref.initInstanceProps,
      validateProps = _ref.validateProps;

  return _temp = _class = function (_React$Component) {
    inherits(List, _React$Component);

    function List(props) {
      classCallCheck(this, List);

      var _this = possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this, props));

      _this._cellStyleCache = {};
      _this._resetIsScrollingTimeoutId = null;
      _this.state = {
        isScrolling: false,
        horizontalScrollDirection: 'forward',
        scrollLeft: 0,
        scrollTop: 0,
        verticalScrollDirection: 'forward'
      };

      _this.onScroll = function (event) {
        var _event$currentTarget = event.currentTarget,
            scrollLeft = _event$currentTarget.scrollLeft,
            scrollTop = _event$currentTarget.scrollTop;

        _this.setState(function (prevState) {
          return {
            isScrolling: true,
            horizontalScrollDirection: prevState.scrollLeft < scrollLeft ? 'forward' : 'backward',
            scrollLeft: scrollLeft,
            scrollTop: scrollTop,
            verticalScrollDirection: prevState.scrollTop < scrollTop ? 'forward' : 'backward'
          };
        }, _this.resetIsScrollingDebounced);
      };

      _this.scrollingContainerRef = function (ref) {
        _this._scrollingContainer = ref;
      };

      _this.resetIsScrollingDebounced = function () {
        if (_this._resetIsScrollingTimeoutId !== null) {
          clearTimeout(_this._resetIsScrollingTimeoutId);
        }

        _this._resetIsScrollingTimeoutId = setTimeout(_this.resetIsScrolling, IS_SCROLLING_DEBOUNCE_INTERVAL);
      };

      _this.resetIsScrolling = function () {
        _this._resetIsScrollingTimeoutId = null;

        _this.setState({ isScrolling: false }, function () {
          // Clear style cache after state update has been committed.
          // This way we don't break pure sCU for cells that don't use isScrolling param.
          _this._cellStyleCache = {};
        });
      };

      _this._instanceProps = initInstanceProps(props, _this);
      return _this;
    }

    createClass(List, [{
      key: 'scrollTo',
      value: function scrollTo(_ref2) {
        var scrollLeft = _ref2.scrollLeft,
            scrollTop = _ref2.scrollTop;

        if (this._scrollingContainer != null) {
          this._scrollingContainer.scrollLeft = scrollLeft;
          this._scrollingContainer.scrollTop = scrollTop;
        }
      }
    }, {
      key: 'scrollToItem',
      value: function scrollToItem(_ref3) {
        var _ref3$align = _ref3.align,
            align = _ref3$align === undefined ? 'auto' : _ref3$align,
            columnIndex = _ref3.columnIndex,
            rowIndex = _ref3.rowIndex;
        var _state = this.state,
            scrollLeft = _state.scrollLeft,
            scrollTop = _state.scrollTop;


        this.scrollTo({
          scrollLeft: getOffsetForColumnAndAlignment(this.props, columnIndex, align, scrollLeft, this._instanceProps),
          scrollTop: getOffsetForRowAndAlignment(this.props, rowIndex, align, scrollTop, this._instanceProps)
        });
      }
    }, {
      key: 'componnetWillUnmount',
      value: function componnetWillUnmount() {
        if (this._resetIsScrollingTimeoutId !== null) {
          clearTimeout(this._resetIsScrollingTimeoutId);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            className = _props.className,
            height = _props.height,
            style = _props.style,
            width = _props.width;
        var isScrolling = this.state.isScrolling;


        var estimatedTotalHeight = getEstimatedTotalHeight(this.props, this._instanceProps);
        var estimatedTotalWidth = getEstimatedTotalWidth(this.props, this._instanceProps);

        return React.createElement(
          'div',
          {
            className: className,
            ref: this.scrollingContainerRef,
            style: _extends({
              position: 'relative',
              height: height,
              width: width,
              overflow: 'auto'
            }, style),
            onScroll: this.onScroll
          },
          React.createElement(
            'div',
            {
              style: {
                height: estimatedTotalHeight,
                overflow: 'hidden',
                pointerEvents: isScrolling ? 'none' : '',
                width: estimatedTotalWidth
              }
            },
            this.renderCells()
          )
        );
      }
    }, {
      key: 'renderCells',
      value: function renderCells() {
        var _props2 = this.props,
            children = _props2.children,
            useIsScrolling = _props2.useIsScrolling;
        var isScrolling = this.state.isScrolling;

        var _getHorizontalRangeTo = this.getHorizontalRangeToRender(),
            _getHorizontalRangeTo2 = slicedToArray(_getHorizontalRangeTo, 2),
            columnStartIndex = _getHorizontalRangeTo2[0],
            columnStopIndex = _getHorizontalRangeTo2[1];

        var _getVerticalRangeToRe = this.getVerticalRangeToRender(),
            _getVerticalRangeToRe2 = slicedToArray(_getVerticalRangeToRe, 2),
            rowStartIndex = _getVerticalRangeToRe2[0],
            rowStopIndex = _getVerticalRangeToRe2[1];

        var cells = [];

        for (var _rowIndex = rowStartIndex; _rowIndex <= rowStopIndex; _rowIndex++) {
          for (var _columnIndex = columnStartIndex; _columnIndex <= columnStopIndex; _columnIndex++) {
            var _key = _rowIndex + ':' + _columnIndex;

            // Cache cell styles while scrolling,
            // So that pure component sCU will prevent re-renders.
            var _style = void 0;
            if (this._cellStyleCache.hasOwnProperty(_key)) {
              _style = this._cellStyleCache[_key];
            } else {
              this._cellStyleCache[_key] = _style = {
                position: 'absolute',
                left: getColumnOffset(this.props, _columnIndex, this._instanceProps),
                top: getRowOffset(this.props, _rowIndex, this._instanceProps),
                height: getRowHeight(this.props, _rowIndex, this._instanceProps),
                width: getColumnWidth(this.props, _columnIndex, this._instanceProps)
              };
            }

            cells.push(children({
              columnIndex: _columnIndex,
              key: _key,
              isScrolling: useIsScrolling ? isScrolling : undefined,
              rowIndex: _rowIndex,
              style: _style
            }));
          }
        }

        return cells;
      }
    }, {
      key: 'getHorizontalRangeToRender',
      value: function getHorizontalRangeToRender() {
        var _props3 = this.props,
            columnCount = _props3.columnCount,
            overscanCount = _props3.overscanCount;
        var _state2 = this.state,
            horizontalScrollDirection = _state2.horizontalScrollDirection,
            scrollLeft = _state2.scrollLeft;


        var startIndex = getColumnStartIndexForOffset(this.props, scrollLeft, this._instanceProps);
        var stopIndex = getColumnStopIndexForStartIndex(this.props, startIndex, this._instanceProps);

        // Overscan by one cell in each direction so that tab/focus works.
        // If there isn't at least one extra cell, tab loops back around.
        var overscanBackward = horizontalScrollDirection === 'backward' ? Math.max(1, overscanCount) : 1;
        var overscanForward = horizontalScrollDirection === 'forward' ? Math.max(1, overscanCount) : 1;

        return [Math.max(0, startIndex - overscanBackward), Math.min(columnCount - 1, stopIndex + overscanForward)];
      }
    }, {
      key: 'getVerticalRangeToRender',
      value: function getVerticalRangeToRender() {
        var _props4 = this.props,
            columnCount = _props4.columnCount,
            overscanCount = _props4.overscanCount;
        var _state3 = this.state,
            verticalScrollDirection = _state3.verticalScrollDirection,
            scrollTop = _state3.scrollTop;


        var startIndex = getRowStartIndexForOffset(this.props, scrollTop, this._instanceProps);
        var stopIndex = getRowStopIndexForStartIndex(this.props, startIndex, this._instanceProps);

        // Overscan by one cell in each direction so that tab/focus works.
        // If there isn't at least one extra cell, tab loops back around.
        var overscanBackward = verticalScrollDirection === 'backward' ? Math.max(1, overscanCount) : 1;
        var overscanForward = verticalScrollDirection === 'forward' ? Math.max(1, overscanCount) : 1;

        return [Math.max(0, startIndex - overscanBackward), Math.min(columnCount - 1, stopIndex + overscanForward)];
      }
    }], [{
      key: 'getDerivedStateFromProps',
      value: function getDerivedStateFromProps(nextProps, prevState) {
        validateSharedProps(nextProps);
        validateProps(nextProps);
        return null;
      }
    }]);
    return List;
  }(React.Component), _class.defaultProps = {
    overscanCount: 1,
    useIsScrolling: false
  }, _temp;
}

var validateSharedProps = function validateSharedProps(_ref4) {
  var children = _ref4.children,
      height = _ref4.height,
      width = _ref4.width;

  if (process.env.NODE_ENV !== 'production') {
    if (typeof children !== 'function') {
      throw Error('An invalid "children" prop has been specified. ' + 'Value should be a function that creates a React element. ' + ('"' + (children === null ? 'null' : typeof children === 'undefined' ? 'undefined' : _typeof(children)) + '" was specified.'));
    }

    if (typeof width !== 'number') {
      throw Error('An invalid "width" prop has been specified. ' + 'Grids must specify a number for width. ' + ('"' + (width === null ? 'null' : typeof width === 'undefined' ? 'undefined' : _typeof(width)) + '" was specified.'));
    }

    if (typeof height !== 'number') {
      throw Error('An invalid "height" prop has been specified. ' + 'Grids must specify a number for height. ' + ('"' + (height === null ? 'null' : typeof height === 'undefined' ? 'undefined' : _typeof(height)) + '" was specified.'));
    }
  }
};

var DEFAULT_ESTIMATED_CELL_SIZE = 50;

var getCellMetadata = function getCellMetadata(cellType, props, index, instanceProps) {
  var cellMetadataMap = void 0,
      cellSize = void 0,
      estimatedCellSize = void 0,
      lastMeasuredIndex = void 0;
  if (cellType === 'column') {
    cellMetadataMap = instanceProps.columnMetadataMap;
    cellSize = props.columnWidth;
    estimatedCellSize = instanceProps.estimatedColumnWidth;
    lastMeasuredIndex = instanceProps.lastMeasuredColumnIndex;
  } else {
    cellMetadataMap = instanceProps.rowMetadataMap;
    cellSize = props.rowHeight;
    estimatedCellSize = instanceProps.estimatedRowHeight;
    lastMeasuredIndex = instanceProps.lastMeasuredRowIndex;
  }

  if (index > lastMeasuredIndex) {
    var _offset = 0;
    if (lastMeasuredIndex >= 0) {
      var cellMetadata = cellMetadataMap[lastMeasuredIndex];
      _offset = cellMetadata.offset + cellMetadata.size;
    }

    for (var i = lastMeasuredIndex + 1; i <= index; i++) {
      var _size = cellSize(i);

      cellMetadataMap[i] = {
        offset: _offset,
        size: _size
      };

      _offset += _size;
    }

    if (cellType === 'column') {
      instanceProps.lastMeasuredColumnIndex = index;
    } else {
      instanceProps.lastMeasuredRowIndex = index;
    }
  }

  return cellMetadataMap[index];
};

var findNearestCell = function findNearestCell(cellType, props, instanceProps, offset) {
  var cellMetadataMap = void 0,
      estimatedCellSize = void 0,
      lastMeasuredIndex = void 0;
  if (cellType === 'column') {
    cellMetadataMap = instanceProps.columnMetadataMap;
    estimatedCellSize = instanceProps.estimatedColumnWidth;
    lastMeasuredIndex = instanceProps.lastMeasuredColumnIndex;
  } else {
    cellMetadataMap = instanceProps.rowMetadataMap;
    estimatedCellSize = instanceProps.estimatedRowHeight;
    lastMeasuredIndex = instanceProps.lastMeasuredRowIndex;
  }

  var lastMeasuredCellOffset = lastMeasuredIndex > 0 ? cellMetadataMap[lastMeasuredIndex].offset : 0;

  if (lastMeasuredCellOffset >= offset) {
    // If we've already measured cells within this range just use a binary search as it's faster.
    return findNearestCellBinarySearch(cellType, props, instanceProps, lastMeasuredIndex, 0, offset);
  } else {
    // If we haven't yet measured this high, fallback to an exponential search with an inner binary search.
    // The exponential search avoids pre-computing sizes for the full set of cells as a binary search would.
    // The overall complexity for this approach is O(log n).
    return findNearestCellExponentialSearch(cellType, props, instanceProps, lastMeasuredIndex, offset);
  }
};

var findNearestCellBinarySearch = function findNearestCellBinarySearch(cellType, props, instanceProps, high, low, offset) {
  while (low <= high) {
    var middle = low + Math.floor((high - low) / 2);
    var currentOffset = getCellMetadata(cellType, props, middle, instanceProps).offset;

    if (currentOffset === offset) {
      return middle;
    } else if (currentOffset < offset) {
      low = middle + 1;
    } else if (currentOffset > offset) {
      high = middle - 1;
    }
  }

  if (low > 0) {
    return low - 1;
  } else {
    return 0;
  }
};

var findNearestCellExponentialSearch = function findNearestCellExponentialSearch(cellType, props, instanceProps, index, offset) {
  var count = cellType === 'column' ? props.columnCount : props.rowCount;
  var interval = 1;

  while (index < count && getCellMetadata(cellType, props, index, instanceProps).offset < offset) {
    index += interval;
    interval *= 2;
  }

  return findNearestCellBinarySearch(cellType, props, instanceProps, Math.min(index, count - 1), Math.floor(index / 2), offset);
};

var getOffsetForIndexAndAlignment = function getOffsetForIndexAndAlignment(cellType, props, index, align, scrollOffset, instanceProps) {
  var size = cellType === 'column' ? props.width : props.height;
  var cellMetadata = getCellMetadata(cellType, props, index, instanceProps);
  var maxOffset = cellMetadata.offset;
  var minOffset = cellMetadata.offset - size + cellMetadata.size;

  switch (align) {
    case 'start':
      return maxOffset;
    case 'end':
      return minOffset;
    case 'center':
      return Math.round(minOffset + (maxOffset - minOffset) / 2);
    case 'auto':
    default:
      if (scrollOffset >= minOffset && scrollOffset <= maxOffset) {
        return scrollOffset;
      } else if (scrollOffset - minOffset < maxOffset - scrollOffset) {
        return minOffset;
      } else {
        return maxOffset;
      }
  }
};

var DynamicGrid = createGridComponent({
  getColumnOffset: function getColumnOffset(props, index, instanceProps) {
    return getCellMetadata('column', props, index, instanceProps).offset;
  },

  getColumnStartIndexForOffset: function getColumnStartIndexForOffset(props, offset, instanceProps) {
    return findNearestCell('column', props, instanceProps, offset);
  },

  getColumnStopIndexForStartIndex: function getColumnStopIndexForStartIndex(props, startIndex, instanceProps) {
    var columnCount = props.columnCount,
        width = props.width;


    var cellMetadata = getCellMetadata('column', props, startIndex, instanceProps);
    var maxOffset = cellMetadata.offset + width;

    var offset = cellMetadata.offset;
    var stopIndex = startIndex;

    while (stopIndex < columnCount - 1 && offset < maxOffset) {
      stopIndex++;
      offset += getCellMetadata('column', props, stopIndex, instanceProps).size;
    }

    return stopIndex;
  },

  getColumnWidth: function getColumnWidth(props, index, instanceProps) {
    return instanceProps.columnMetadataMap[index].size;
  },

  getEstimatedTotalHeight: function getEstimatedTotalHeight(_ref, _ref2) {
    var rowCount = _ref.rowCount;
    var rowMetadataMap = _ref2.rowMetadataMap,
        estimatedRowHeight = _ref2.estimatedRowHeight,
        lastMeasuredRowIndex = _ref2.lastMeasuredRowIndex;

    var totalSizeOfMeasuredRows = 0;

    if (lastMeasuredRowIndex >= 0) {
      var cellMetadata = rowMetadataMap[lastMeasuredRowIndex];
      totalSizeOfMeasuredRows = cellMetadata.offset + cellMetadata.size;
    }

    var numUnmeasuredCells = rowCount - lastMeasuredRowIndex - 1;
    var totalSizeOfUnmeasuredCells = numUnmeasuredCells * estimatedRowHeight;

    return totalSizeOfMeasuredRows + totalSizeOfUnmeasuredCells;
  },

  getEstimatedTotalWidth: function getEstimatedTotalWidth(_ref3, _ref4) {
    var columnCount = _ref3.columnCount;
    var columnMetadataMap = _ref4.columnMetadataMap,
        estimatedColumnWidth = _ref4.estimatedColumnWidth,
        lastMeasuredColumnIndex = _ref4.lastMeasuredColumnIndex;

    var totalSizeOfMeasuredRows = 0;

    if (lastMeasuredColumnIndex >= 0) {
      var cellMetadata = columnMetadataMap[lastMeasuredColumnIndex];
      totalSizeOfMeasuredRows = cellMetadata.offset + cellMetadata.size;
    }

    var numUnmeasuredCells = columnCount - lastMeasuredColumnIndex - 1;
    var totalSizeOfUnmeasuredCells = numUnmeasuredCells * estimatedColumnWidth;

    return totalSizeOfMeasuredRows + totalSizeOfUnmeasuredCells;
  },

  getOffsetForColumnAndAlignment: function getOffsetForColumnAndAlignment(props, index, align, scrollOffset, instanceProps) {
    return getOffsetForIndexAndAlignment('column', props, index, align, scrollOffset, instanceProps);
  },

  getOffsetForRowAndAlignment: function getOffsetForRowAndAlignment(props, index, align, scrollOffset, instanceProps) {
    return getOffsetForIndexAndAlignment('row', props, index, align, scrollOffset, instanceProps);
  },

  getRowOffset: function getRowOffset(props, index, instanceProps) {
    return getCellMetadata('row', props, index, instanceProps).offset;
  },

  getRowHeight: function getRowHeight(props, index, instanceProps) {
    return instanceProps.rowMetadataMap[index].size;
  },

  getRowStartIndexForOffset: function getRowStartIndexForOffset(props, offset, instanceProps) {
    return findNearestCell('row', props, instanceProps, offset);
  },

  getRowStopIndexForStartIndex: function getRowStopIndexForStartIndex(props, startIndex, instanceProps) {
    var rowCount = props.rowCount,
        height = props.height;


    var cellMetadata = getCellMetadata('row', props, startIndex, instanceProps);
    var maxOffset = cellMetadata.offset + height;

    var offset = cellMetadata.offset;
    var stopIndex = startIndex;

    while (stopIndex < rowCount - 1 && offset < maxOffset) {
      stopIndex++;
      offset += getCellMetadata('row', props, stopIndex, instanceProps).size;
    }

    return stopIndex;
  },

  initInstanceProps: function initInstanceProps(props, instance) {
    var _ref5 = props,
        estimatedColumnWidth = _ref5.estimatedColumnWidth,
        estimatedRowHeight = _ref5.estimatedRowHeight;


    var instanceProps = {
      columnMetadataMap: {},
      estimatedColumnWidth: estimatedColumnWidth || DEFAULT_ESTIMATED_CELL_SIZE,
      estimatedRowHeight: estimatedRowHeight || DEFAULT_ESTIMATED_CELL_SIZE,
      lastMeasuredColumnIndex: -1,
      lastMeasuredRowIndex: -1,
      rowMetadataMap: {}
    };

    instance.resetAfterColumnIndex = function (index) {
      instanceProps.lastMeasuredColumnIndex = index - 1;
    };

    instance.resetAfterRowIndex = function (index) {
      instanceProps.lastMeasuredRowIndex = index - 1;
    };

    return instanceProps;
  },


  validateProps: function validateProps(_ref6) {
    var columnWidth = _ref6.columnWidth,
        rowHeight = _ref6.rowHeight;

    if (process.env.NODE_ENV !== 'production') {
      if (typeof columnWidth !== 'function') {
        throw Error('An invalid "columnWidth" prop has been specified. ' + 'Value should be a function. ' + ('"' + (columnWidth === null ? 'null' : typeof columnWidth === 'undefined' ? 'undefined' : _typeof(columnWidth)) + '" was specified.'));
      } else if (typeof rowHeight !== 'function') {
        throw Error('An invalid "rowHeight" prop has been specified. ' + 'Value should be a function. ' + ('"' + (rowHeight === null ? 'null' : typeof rowHeight === 'undefined' ? 'undefined' : _typeof(rowHeight)) + '" was specified.'));
      }
    }
  }
});

var IS_SCROLLING_DEBOUNCE_INTERVAL$1 = 150;

function createListComponent(_ref) {
  var _class, _temp;

  var getCellOffset = _ref.getCellOffset,
      getCellSize = _ref.getCellSize,
      getEstimatedTotalSize = _ref.getEstimatedTotalSize,
      getOffsetForIndexAndAlignment = _ref.getOffsetForIndexAndAlignment,
      getStartIndexForOffset = _ref.getStartIndexForOffset,
      getStopIndexForStartIndex = _ref.getStopIndexForStartIndex,
      initInstanceProps = _ref.initInstanceProps,
      validateProps = _ref.validateProps;

  return _temp = _class = function (_React$Component) {
    inherits(List, _React$Component);

    function List(props) {
      classCallCheck(this, List);

      var _this = possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this, props));

      _this._cellStyleCache = {};
      _this._resetIsScrollingTimeoutId = null;
      _this.state = {
        isScrolling: false,
        scrollDirection: 'forward',
        scrollOffset: 0
      };

      _this.onScrollHorizontal = function (event) {
        var scrollLeft = event.currentTarget.scrollLeft;

        _this.setState(function (prevState) {
          return {
            isScrolling: true,
            scrollDirection: prevState.scrollOffset < scrollLeft ? 'forward' : 'backward',
            scrollOffset: scrollLeft
          };
        }, _this.resetIsScrollingDebounced);
      };

      _this.onScrollVertical = function (event) {
        var scrollTop = event.currentTarget.scrollTop;

        _this.setState(function (prevState) {
          return {
            isScrolling: true,
            scrollDirection: prevState.scrollOffset < scrollTop ? 'forward' : 'backward',
            scrollOffset: scrollTop
          };
        }, _this.resetIsScrollingDebounced);
      };

      _this.scrollingContainerRef = function (ref) {
        _this._scrollingContainer = ref;
      };

      _this.resetIsScrollingDebounced = function () {
        if (_this._resetIsScrollingTimeoutId !== null) {
          clearTimeout(_this._resetIsScrollingTimeoutId);
        }

        _this._resetIsScrollingTimeoutId = setTimeout(_this.resetIsScrolling, IS_SCROLLING_DEBOUNCE_INTERVAL$1);
      };

      _this.resetIsScrolling = function () {
        _this._resetIsScrollingTimeoutId = null;

        _this.setState({ isScrolling: false }, function () {
          // Clear style cache after state update has been committed.
          // This way we don't break pure sCU for cells that don't use isScrolling param.
          _this._cellStyleCache = {};
        });
      };

      _this._instanceProps = initInstanceProps(props, _this);
      return _this;
    }

    createClass(List, [{
      key: 'scrollTo',
      value: function scrollTo(scrollOffset) {
        if (this._scrollingContainer != null) {
          var _direction = this.props.direction;


          if (_direction === 'horizontal') {
            this._scrollingContainer.scrollLeft = scrollOffset;
          } else {
            this._scrollingContainer.scrollTop = scrollOffset;
          }
        }
      }
    }, {
      key: 'scrollToItem',
      value: function scrollToItem(index) {
        var align = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'auto';

        if (this._scrollingContainer != null) {
          var _scrollOffset = this.state.scrollOffset;

          this.scrollTo(getOffsetForIndexAndAlignment(this.props, index, align, _scrollOffset, this._instanceProps));
        }
      }
    }, {
      key: 'componnetWillUnmount',
      value: function componnetWillUnmount() {
        if (this._resetIsScrollingTimeoutId !== null) {
          clearTimeout(this._resetIsScrollingTimeoutId);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            className = _props.className,
            direction = _props.direction,
            height = _props.height,
            style = _props.style,
            width = _props.width;
        var isScrolling = this.state.isScrolling;


        var onScroll = direction === 'vertical' ? this.onScrollVertical : this.onScrollHorizontal;

        var estimatedTotalSize = getEstimatedTotalSize(this.props, this._instanceProps);

        return React.createElement(
          'div',
          {
            className: className,
            ref: this.scrollingContainerRef,
            style: _extends({
              position: 'relative',
              height: height,
              width: width,
              overflow: 'auto'
            }, style),
            onScroll: onScroll
          },
          React.createElement(
            'div',
            {
              style: {
                height: direction === 'horizontal' ? height : estimatedTotalSize,
                overflow: 'hidden',
                pointerEvents: isScrolling ? 'none' : '',
                width: direction === 'horizontal' ? estimatedTotalSize : width
              }
            },
            this.renderCells()
          )
        );
      }
    }, {
      key: 'renderCells',
      value: function renderCells() {
        var _props2 = this.props,
            children = _props2.children,
            direction = _props2.direction,
            useIsScrolling = _props2.useIsScrolling;
        var isScrolling = this.state.isScrolling;

        var _getRangeToRender = this.getRangeToRender(),
            _getRangeToRender2 = slicedToArray(_getRangeToRender, 2),
            startIndex = _getRangeToRender2[0],
            stopIndex = _getRangeToRender2[1];

        var cells = [];

        for (var _index = startIndex; _index <= stopIndex; _index++) {
          var _key = '' + _index;

          // Cache cell styles while scrolling,
          // So that pure component sCU will prevent re-renders.
          var _style = void 0;
          if (this._cellStyleCache.hasOwnProperty(_index)) {
            _style = this._cellStyleCache[_index];
          } else {
            this._cellStyleCache[_index] = _style = {
              position: 'absolute',
              left: direction === 'horizontal' ? getCellOffset(this.props, _index, this._instanceProps) : 0,
              top: direction === 'vertical' ? getCellOffset(this.props, _index, this._instanceProps) : 0,
              height: direction === 'vertical' ? getCellSize(this.props, _index, this._instanceProps) : '100%',
              width: direction === 'horizontal' ? getCellSize(this.props, _index, this._instanceProps) : '100%'
            };
          }

          cells.push(children({
            key: _key,
            index: _index,
            isScrolling: useIsScrolling ? isScrolling : undefined,
            style: _style
          }));
        }

        return cells;
      }
    }, {
      key: 'getRangeToRender',
      value: function getRangeToRender() {
        var _props3 = this.props,
            count = _props3.count,
            overscanCount = _props3.overscanCount;
        var _state = this.state,
            scrollDirection = _state.scrollDirection,
            scrollOffset = _state.scrollOffset;


        var startIndex = getStartIndexForOffset(this.props, scrollOffset, this._instanceProps);
        var stopIndex = getStopIndexForStartIndex(this.props, startIndex, this._instanceProps);

        // Overscan by one cell in each direction so that tab/focus works.
        // If there isn't at least one extra cell, tab loops back around.
        var overscanBackward = scrollDirection === 'backward' ? Math.max(1, overscanCount) : 1;
        var overscanForward = scrollDirection === 'forward' ? Math.max(1, overscanCount) : 1;

        return [Math.max(0, startIndex - overscanBackward), Math.min(count - 1, stopIndex + overscanForward)];
      }
    }], [{
      key: 'getDerivedStateFromProps',
      value: function getDerivedStateFromProps(nextProps, prevState) {
        validateSharedProps$1(nextProps);
        validateProps(nextProps);
        return null;
      }
    }]);
    return List;
  }(React.Component), _class.defaultProps = {
    direction: 'vertical',
    overscanCount: 2,
    useIsScrolling: false
  }, _temp;
}

var validateSharedProps$1 = function validateSharedProps(_ref2) {
  var children = _ref2.children,
      direction = _ref2.direction,
      height = _ref2.height,
      width = _ref2.width;

  if (process.env.NODE_ENV !== 'production') {
    if (direction !== 'horizontal' && direction !== 'vertical') {
      throw Error('An invalid "direction" prop has been specified. ' + 'Value should be either "horizontal" or "vertical". ' + ('"' + direction + '" was specified.'));
    }

    if (typeof children !== 'function') {
      throw Error('An invalid "children" prop has been specified. ' + 'Value should be a function that creates a React element. ' + ('"' + (children === null ? 'null' : typeof children === 'undefined' ? 'undefined' : _typeof(children)) + '" was specified.'));
    }

    if (direction === 'horizontal' && typeof width !== 'number') {
      throw Error('An invalid "width" prop has been specified. ' + 'Horizontal lists must specify a number for width. ' + ('"' + (width === null ? 'null' : typeof width === 'undefined' ? 'undefined' : _typeof(width)) + '" was specified.'));
    } else if (direction === 'vertical' && typeof height !== 'number') {
      throw Error('An invalid "height" prop has been specified. ' + 'Vertical lists must specify a number for height. ' + ('"' + (height === null ? 'null' : typeof height === 'undefined' ? 'undefined' : _typeof(height)) + '" was specified.'));
    }
  }
};

var DEFAULT_ESTIMATED_CELL_SIZE$1 = 50;

var getCellMetadata$1 = function getCellMetadata(props, index, instanceProps) {
  var _ref = props,
      cellSize = _ref.cellSize,
      estimatedCellSize = _ref.estimatedCellSize;
  var cellMetadataMap = instanceProps.cellMetadataMap,
      lastMeasuredIndex = instanceProps.lastMeasuredIndex;


  if (index > lastMeasuredIndex) {
    var _offset = 0;
    if (lastMeasuredIndex >= 0) {
      var cellMetadata = cellMetadataMap[lastMeasuredIndex];
      _offset = cellMetadata.offset + cellMetadata.size;
    }

    for (var i = lastMeasuredIndex + 1; i <= index; i++) {
      var _size = cellSize(i);

      cellMetadataMap[i] = {
        offset: _offset,
        size: _size
      };

      _offset += _size;
    }

    instanceProps.lastMeasuredIndex = index;
  }

  return cellMetadataMap[index];
};

var findNearestCell$1 = function findNearestCell(props, instanceProps, offset) {
  var cellMetadataMap = instanceProps.cellMetadataMap,
      estimatedCellSize = instanceProps.estimatedCellSize,
      lastMeasuredIndex = instanceProps.lastMeasuredIndex;


  var lastMeasuredCellOffset = lastMeasuredIndex > 0 ? cellMetadataMap[lastMeasuredIndex].offset : 0;

  if (lastMeasuredCellOffset >= offset) {
    // If we've already measured cells within this range just use a binary search as it's faster.
    return findNearestCellBinarySearch$1(props, instanceProps, lastMeasuredIndex, 0, offset);
  } else {
    // If we haven't yet measured this high, fallback to an exponential search with an inner binary search.
    // The exponential search avoids pre-computing sizes for the full set of cells as a binary search would.
    // The overall complexity for this approach is O(log n).
    return findNearestCellExponentialSearch$1(props, instanceProps, lastMeasuredIndex, offset);
  }
};

var findNearestCellBinarySearch$1 = function findNearestCellBinarySearch(props, instanceProps, high, low, offset) {
  while (low <= high) {
    var middle = low + Math.floor((high - low) / 2);
    var currentOffset = getCellMetadata$1(props, middle, instanceProps).offset;

    if (currentOffset === offset) {
      return middle;
    } else if (currentOffset < offset) {
      low = middle + 1;
    } else if (currentOffset > offset) {
      high = middle - 1;
    }
  }

  if (low > 0) {
    return low - 1;
  } else {
    return 0;
  }
};

var findNearestCellExponentialSearch$1 = function findNearestCellExponentialSearch(props, instanceProps, index, offset) {
  var count = props.count;

  var interval = 1;

  while (index < count && getCellMetadata$1(props, index, instanceProps).offset < offset) {
    index += interval;
    interval *= 2;
  }

  return findNearestCellBinarySearch$1(props, instanceProps, Math.min(index, count - 1), Math.floor(index / 2), offset);
};

var DynamicList = createListComponent({
  getCellOffset: function getCellOffset(props, index, instanceProps) {
    return getCellMetadata$1(props, index, instanceProps).offset;
  },

  getCellSize: function getCellSize(props, index, instanceProps) {
    return instanceProps.cellMetadataMap[index].size;
  },

  getEstimatedTotalSize: function getEstimatedTotalSize(_ref2, _ref3) {
    var count = _ref2.count;
    var cellMetadataMap = _ref3.cellMetadataMap,
        estimatedCellSize = _ref3.estimatedCellSize,
        lastMeasuredIndex = _ref3.lastMeasuredIndex;

    var totalSizeOfMeasuredCells = 0;

    if (lastMeasuredIndex >= 0) {
      var cellMetadata = cellMetadataMap[lastMeasuredIndex];
      totalSizeOfMeasuredCells = cellMetadata.offset + cellMetadata.size;
    }

    var numUnmeasuredCells = count - lastMeasuredIndex - 1;
    var totalSizeOfUnmeasuredCells = numUnmeasuredCells * estimatedCellSize;

    return totalSizeOfMeasuredCells + totalSizeOfUnmeasuredCells;
  },

  getOffsetForIndexAndAlignment: function getOffsetForIndexAndAlignment(props, index, align, scrollOffset, instanceProps) {
    var direction = props.direction,
        height = props.height,
        width = props.width;


    var size = direction === 'horizontal' ? width : height;
    var cellMetadata = getCellMetadata$1(props, index, instanceProps);
    var maxOffset = cellMetadata.offset;
    var minOffset = cellMetadata.offset - size + cellMetadata.size;

    switch (align) {
      case 'start':
        return maxOffset;
      case 'end':
        return minOffset;
      case 'center':
        return Math.round(minOffset + (maxOffset - minOffset) / 2);
      case 'auto':
      default:
        if (scrollOffset >= minOffset && scrollOffset <= maxOffset) {
          return scrollOffset;
        } else if (scrollOffset - minOffset < maxOffset - scrollOffset) {
          return minOffset;
        } else {
          return maxOffset;
        }
    }
  },

  getStartIndexForOffset: function getStartIndexForOffset(props, offset, instanceProps) {
    return findNearestCell$1(props, instanceProps, offset);
  },

  getStopIndexForStartIndex: function getStopIndexForStartIndex(props, startIndex, instanceProps) {
    var count = props.count,
        direction = props.direction,
        height = props.height,
        width = props.width;


    var size = direction === 'horizontal' ? width : height;
    var cellMetadata = getCellMetadata$1(props, startIndex, instanceProps);
    var maxOffset = cellMetadata.offset + size;

    var offset = cellMetadata.offset;
    var stopIndex = startIndex;

    while (stopIndex < count - 1 && offset < maxOffset) {
      stopIndex++;
      offset += getCellMetadata$1(props, stopIndex, instanceProps).size;
    }

    return stopIndex;
  },

  initInstanceProps: function initInstanceProps(props, instance) {
    var _ref4 = props,
        estimatedCellSize = _ref4.estimatedCellSize,
        direction = _ref4.direction;


    var instanceProps = {
      cellMetadataMap: {},
      estimatedCellSize: estimatedCellSize || DEFAULT_ESTIMATED_CELL_SIZE$1,
      lastMeasuredIndex: -1
    };

    instance.resetAfterIndex = function (index) {
      instanceProps.lastMeasuredIndex = index - 1;
    };

    return instanceProps;
  },


  validateProps: function validateProps(_ref5) {
    var cellSize = _ref5.cellSize;

    if (process.env.NODE_ENV !== 'production') {
      if (typeof cellSize !== 'function') {
        throw Error('An invalid "cellSize" prop has been specified. ' + 'Value should be a function. ' + ('"' + (cellSize === null ? 'null' : typeof cellSize === 'undefined' ? 'undefined' : _typeof(cellSize)) + '" was specified.'));
      }
    }
  }
});

var FixedSizeGrid = createGridComponent({
  getColumnOffset: function getColumnOffset(_ref, index) {
    var columnWidth = _ref.columnWidth;
    return index * columnWidth;
  },

  getColumnWidth: function getColumnWidth(_ref2, index) {
    var columnWidth = _ref2.columnWidth;
    return columnWidth;
  },

  getRowOffset: function getRowOffset(_ref3, index) {
    var rowHeight = _ref3.rowHeight;
    return index * rowHeight;
  },

  getRowHeight: function getRowHeight(_ref4, index) {
    var rowHeight = _ref4.rowHeight;
    return rowHeight;
  },

  getEstimatedTotalHeight: function getEstimatedTotalHeight(_ref5) {
    var rowCount = _ref5.rowCount,
        rowHeight = _ref5.rowHeight;
    return rowHeight * rowCount;
  },

  getEstimatedTotalWidth: function getEstimatedTotalWidth(_ref6) {
    var columnCount = _ref6.columnCount,
        columnWidth = _ref6.columnWidth;
    return columnWidth * columnCount;
  },

  getOffsetForColumnAndAlignment: function getOffsetForColumnAndAlignment(_ref7, columnIndex, align, scrollLeft) {
    var columnWidth = _ref7.columnWidth,
        width = _ref7.width;

    var maxOffset = columnIndex * columnWidth;
    var minOffset = columnIndex * columnWidth - width + columnWidth;

    switch (align) {
      case 'start':
        return maxOffset;
      case 'end':
        return minOffset;
      case 'center':
        return Math.round(minOffset + (maxOffset - minOffset) / 2);
      case 'auto':
      default:
        if (scrollLeft >= minOffset && scrollLeft <= maxOffset) {
          return scrollLeft;
        } else if (scrollLeft - minOffset < maxOffset - scrollLeft) {
          return minOffset;
        } else {
          return maxOffset;
        }
    }
  },

  getOffsetForRowAndAlignment: function getOffsetForRowAndAlignment(_ref8, rowIndex, align, scrollTop) {
    var rowHeight = _ref8.rowHeight,
        height = _ref8.height;

    var maxOffset = rowIndex * rowHeight;
    var minOffset = rowIndex * rowHeight - height + rowHeight;

    switch (align) {
      case 'start':
        return maxOffset;
      case 'end':
        return minOffset;
      case 'center':
        return Math.round(minOffset + (maxOffset - minOffset) / 2);
      case 'auto':
      default:
        if (scrollTop >= minOffset && scrollTop <= maxOffset) {
          return scrollTop;
        } else if (scrollTop - minOffset < maxOffset - scrollTop) {
          return minOffset;
        } else {
          return maxOffset;
        }
    }
  },

  getColumnStartIndexForOffset: function getColumnStartIndexForOffset(_ref9, offset) {
    var columnWidth = _ref9.columnWidth,
        columnCount = _ref9.columnCount;
    return Math.min(columnCount - 1, Math.floor(offset / columnWidth));
  },

  getColumnStopIndexForStartIndex: function getColumnStopIndexForStartIndex(_ref10, startIndex) {
    var columnWidth = _ref10.columnWidth,
        columnCount = _ref10.columnCount,
        width = _ref10.width;

    return Math.min(columnCount - 1, Math.round(startIndex + width / columnWidth));
  },

  getRowStartIndexForOffset: function getRowStartIndexForOffset(_ref11, offset) {
    var rowHeight = _ref11.rowHeight,
        rowCount = _ref11.rowCount;
    return Math.min(rowCount - 1, Math.floor(offset / rowHeight));
  },

  getRowStopIndexForStartIndex: function getRowStopIndexForStartIndex(_ref12, startIndex) {
    var rowHeight = _ref12.rowHeight,
        rowCount = _ref12.rowCount,
        height = _ref12.height;

    return Math.min(rowCount - 1, Math.round(startIndex + height / rowHeight));
  },

  initInstanceProps: function initInstanceProps(props) {
    // Noop
  },


  validateProps: function validateProps(_ref13) {
    var columnWidth = _ref13.columnWidth,
        rowHeight = _ref13.rowHeight;

    if (process.env.NODE_ENV !== 'production') {
      if (typeof columnWidth !== 'number') {
        throw Error('An invalid "columnWidth" prop has been specified. ' + 'Value should be a number. ' + ('"' + (columnWidth === null ? 'null' : typeof columnWidth === 'undefined' ? 'undefined' : _typeof(columnWidth)) + '" was specified.'));
      }

      if (typeof rowHeight !== 'number') {
        throw Error('An invalid "rowHeight" prop has been specified. ' + 'Value should be a number. ' + ('"' + (rowHeight === null ? 'null' : typeof rowHeight === 'undefined' ? 'undefined' : _typeof(rowHeight)) + '" was specified.'));
      }
    }
  }
});

var FixedSizeList = createListComponent({
  getCellOffset: function getCellOffset(_ref, index) {
    var cellSize = _ref.cellSize,
        size = _ref.size;
    return index * cellSize;
  },

  getCellSize: function getCellSize(_ref2, index) {
    var cellSize = _ref2.cellSize,
        size = _ref2.size;
    return cellSize;
  },

  getEstimatedTotalSize: function getEstimatedTotalSize(_ref3) {
    var cellSize = _ref3.cellSize,
        count = _ref3.count;
    return cellSize * count;
  },

  getOffsetForIndexAndAlignment: function getOffsetForIndexAndAlignment(_ref4, index, align, scrollOffset) {
    var cellSize = _ref4.cellSize,
        direction = _ref4.direction,
        height = _ref4.height,
        width = _ref4.width;

    var maxOffset = index * cellSize;
    var minOffset = index * cellSize - (direction === 'horizontal' ? width : height) + cellSize;

    switch (align) {
      case 'start':
        return maxOffset;
      case 'end':
        return minOffset;
      case 'center':
        return Math.round(minOffset + (maxOffset - minOffset) / 2);
      case 'auto':
      default:
        if (scrollOffset >= minOffset && scrollOffset <= maxOffset) {
          return scrollOffset;
        } else if (scrollOffset - minOffset < maxOffset - scrollOffset) {
          return minOffset;
        } else {
          return maxOffset;
        }
    }
  },

  getStartIndexForOffset: function getStartIndexForOffset(_ref5, offset) {
    var cellSize = _ref5.cellSize,
        count = _ref5.count;
    return Math.min(count - 1, Math.floor(offset / cellSize));
  },

  getStopIndexForStartIndex: function getStopIndexForStartIndex(_ref6, startIndex) {
    var cellSize = _ref6.cellSize,
        count = _ref6.count,
        direction = _ref6.direction,
        height = _ref6.height,
        width = _ref6.width;

    var size = direction === 'horizontal' ? width : height;
    return Math.min(count - 1, Math.round(startIndex + size / cellSize));
  },

  initInstanceProps: function initInstanceProps(props) {
    // Noop
  },


  validateProps: function validateProps(_ref7) {
    var cellSize = _ref7.cellSize;

    if (process.env.NODE_ENV !== 'production') {
      if (typeof cellSize !== 'number') {
        throw Error('An invalid "cellSize" prop has been specified. ' + 'Value should be a number. ' + ('"' + (cellSize === null ? 'null' : typeof cellSize === 'undefined' ? 'undefined' : _typeof(cellSize)) + '" was specified.'));
      }
    }
  }
});

exports.DynamicGrid = DynamicGrid;
exports.DynamicList = DynamicList;
exports.FixedSizeGrid = FixedSizeGrid;
exports.FixedSizeList = FixedSizeList;
